'use strict';

require('babel-polyfill');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _genBase = require('../genBase');

var _genBase2 = _interopRequireDefault(_genBase);

var _ngAddDep = require('ng-add-dep');

var _ngAddDep2 = _interopRequireDefault(_ngAddDep);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _pify = require('pify');

var _pify2 = _interopRequireDefault(_pify);

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = _genBase2.default.extend({
  prompting: function prompting() {
    this.askForModuleName({ url: true, templateUrl: true });

    // convert backslashes to forwardslashes for Windows
    if (this.templateUrl) {
      this.templateUrl = this.templateUrl.replace('\\', '/');
    }
  },
  writing: function writing() {
    var done, config, dependency, newRouteConfig, modulePath, routesPath, wipPath, newState;
    return regeneratorRuntime.async(function writing$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          done = this.async();
          _context.next = 3;
          return regeneratorRuntime.awrap(this.getConfig());

        case 3:
          config = _context.sent;
          dependency = undefined;
          newRouteConfig = undefined;
          modulePath = undefined;
          routesPath = undefined;
          wipPath = undefined;
          newState = undefined;

          dependency = config.ngRoute ? 'ngRoute' : 'ui.router';

          newRouteConfig = {
            appScript: config.appScript,
            controllerAs: config.controllerAs,
            skipController: config.skipController,
            passFunc: config.passFunc,
            ngRoute: config.ngRoute
          };

          // move this logic to utils-route
          config.url = this.url;
          config.lowerCamel = _utils2.default.lowerCamel(this.name.replace('.', '-'));
          config.hyphenName = _utils2.default.hyphenName(this.name.replace('.', '-'));
          config.ctrlName = _utils2.default.ctrlName(this.name.replace('.', '-'));
          config.humanName = _utils2.default.humanName(this.name.replace('.', '-'));

          newState = {
            name: this.name,
            module: this.module,
            url: this.url,
            lowerCamel: config.lowerCamel,
            hyphenName: config.hyphenName,
            ctrlName: config.ctrlName,
            templateUrl: this.templateUrl
          };

          // create module path minus extension
          // if modulePath is empty file name is app
          wipPath = _path2.default.join(this.config.path, '..', config.appDir, config.modulePath, config.modulePath === '' ? 'app' : _utils2.default.hyphenName(config.moduleName));

          // get name-module.{coffee,js,ts}
          _context.next = 21;
          return regeneratorRuntime.awrap(_utils2.default.findModuleFile(wipPath));

        case 21:
          modulePath = _context.sent;
          _context.t0 = regeneratorRuntime;
          _context.t1 = modulePath;
          _context.next = 26;
          return regeneratorRuntime.awrap((0, _pify2.default)(_fs2.default.readFile)(modulePath, 'utf8'));

        case 26:
          _context.t2 = _context.sent;
          _context.t3 = dependency;
          _context.t4 = (0, _ngAddDep2.default)(_context.t2, _context.t3);
          _context.t5 = (0, _pify2.default)(_fs2.default.writeFile)(_context.t1, _context.t4);
          _context.next = 32;
          return _context.t0.awrap.call(_context.t0, _context.t5);

        case 32:
          _context.next = 34;
          return regeneratorRuntime.awrap(_utils2.default.findRoutesFile(wipPath));

        case 34:
          routesPath = _context.sent;
          _context.t6 = regeneratorRuntime;
          _context.t7 = routesPath;
          _context.t8 = _utils2.default;
          _context.next = 40;
          return regeneratorRuntime.awrap((0, _pify2.default)(_fs2.default.readFile)(routesPath, 'utf8'));

        case 40:
          _context.t9 = _context.sent;
          _context.t10 = newState;
          _context.t11 = newRouteConfig;
          _context.t12 = _context.t8.addRoute.call(_context.t8, _context.t9, _context.t10, _context.t11);
          _context.t13 = (0, _pify2.default)(_fs2.default.writeFile)(_context.t7, _context.t12);
          _context.next = 47;
          return _context.t6.awrap.call(_context.t6, _context.t13);

        case 47:

          this.copyE2e(config);

          if (!config.skipController) {
            // call controller subgenerator
            this.composeWith('ng-poly:controller', {
              args: [this.name.replace('.', '-')],
              options: {
                module: this.module,
                structure: this.options.structure,
                markup: this.options.markup,
                'app-script': this.options['app-script'],
                'controller-as': this.options['controller-as'],
                classes: this.options.classes,
                'pass-func': this.options['pass-func'],
                'named-func': this.options['named-func'],
                'test-script': this.options['test-script'],
                'test-dir': this.options['test-dir'],
                style: this.options.style
              }
            }, {
              local: require.resolve('../controller'),
              link: 'strong'
            });
          }

          // call view subgenerator
          this.composeWith('ng-poly:view', {
            args: [_path2.default.basename(this.templateUrl)],
            options: {
              module: this.module,
              structure: this.options.structure,
              markup: this.options.markup,
              'app-script': this.options['app-script'],
              'controller-as': this.options['controller-as'],
              'pass-func': this.options['pass-func'],
              'named-func': this.options['named-func'],
              'test-script': this.options['test-script'],
              'test-dir': this.options['test-dir'],
              'ng-route': this.options['ng-route'],
              style: this.options.style
            }
          }, {
            local: require.resolve('../view'),
            link: 'strong'
          });

          done();

        case 51:
        case 'end':
          return _context.stop();
      }
    }, null, this);
  }
});